library ieee;
use ieee.std_logic_1164.ALL;

entity nBitAddSub0 is    
    port(	a, b			    : in std_logic_vector(3 downto 0);
			m					: in std_logic;
			s                   : out std_logic_vector(3 downto 0);
			carry               : out std_logic);
end nBitAddSub0;

architecture  Behavioral of nBitAddSub0 is
	component FullAdder 
        port(   x, y, z    :    in std_logic;
                sum, c_out  :    out std_logic);
    end component;  

	signal c  				: std_logic_vector(2 downto 0);
		signal sum				: std_logic_vector(3 downto 0);
		signal c_out			: std_logic;
		signal xor_out			: std_logic_vector(3 downto 0);	
		signal clk100Hz		    : std_logic;
		signal mxorb            : std_logic_vector(3 downto 0);

begin
    process(m, b)
    begin
        for j in b'range loop
            mxorb(j) <= m xor b(j);
        end loop;
    end process;       
        
	FA0	: FullAdder port map (x => a(0), y => mxorb(0), z => m, sum => s(0), c_out => c(0));
    FA12	: for i in 1 to 2 generate
		FA1to2:  FullAdder port map(x => a(i), y => mxorb(i), z => c(i-1), sum => s(i), c_out => c(i));
		end generate;
	FA3	: FullAdder port map(x => a(3), y => mxorb(3), z => c(2), sum => s(3), c_out => carry);
end  Behavioral;

library ieee;
use ieee.std_logic_1164.ALL;
entity FullAdder is 
		port(	x, y, z	    :	in std_logic;
                sum, c_out  :   out std_logic);
end FullAdder;
------------------------------------------------------------------------------
architecture designFA of FullAdder is
begin
    sum <= (not x and not y and z) or (not x and y and not z)
		or (x and not y and not z) or (x and y and z);
    c_out <= (x and y) or (x and z) or (y and z);
end designFA;
------------------------------------------------------------------------------