library ieee;
use ieee.std_logic_1164.ALL;

entity nBitAddSub0 is    
    port(	a, b			    : in std_logic_vector(3 downto 0);
			m					: in std_logic;
			s                   : out std_logic_vector(3 downto 0);
			carry               : out std_logic);
end nBitAddSub0;

architecture  Behavioral of nBitAddSub0 is
	component FullAdder 
        port(   x, y, z    :    in std_logic;
                sum, c_out  :    out std_logic);
    end component;  

	signal c  				: std_logic_vector(2 downto 0);
		signal sum				: std_logic_vector(3 downto 0);
		signal c_out			: std_logic;
		signal xor_out			: std_logic_vector(3 downto 0);	
		signal clk100Hz		    : std_logic;

begin
	FA0	: FullAdder 
		port map (a(0), m xor b(0), m, s(0), c(0) );
    FA12	: for i in 1 to 2 generate
		FA1to2:  FullAdder port map(a(i), m xor b(i), c(i-1), s(i), c(i));
		end generate;
	FA3	: FullAdder port map(a(3), m xor b(3), c(2), s(3), carry);
end  Behavioral;

library ieee;
use ieee.std_logic_1164.ALL;
entity FullAdder is 
		port(	x, y, z	    :	in std_logic;
                sum, c_out  :   out std_logic);
end FullAdder;
------------------------------------------------------------------------------
architecture designFA of FullAdder is
begin
    sum <= (not x and not y and z) or (not x and y and not z)
		or (x and not y and not z) or (x and y and z);
    c_out <= (x and y) or (x and z) or (y and z);
end designFA;
------------------------------------------------------------------------------